<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8">
    <meta name="generator" content="GitLab Pages">
    <title>virtiofs - shared file system for virtual machines / Windows HowTo</title>
    <link rel="stylesheet" href="style.css">
  </head>
  <body>
    <div class="navbar">
        <a href="/">Home</a>
    </div>

    <h1>How to install virtiofs drivers on Windows</h1>
    <p>
        This document describes how to manually install the virtiofs drivers
        on Windows.
    </p>

    <p>
        This document assumes you have a guest with a virtiofs device. Documentation for configuring virtiofs devices in libvirt is <a href="https://libvirt.org/kbase/virtiofs.html">here</a>.
    </p>

    <h2>Prerequisites</h2>
    <ul>
        <li>A guest running Microsoft Windows</li>
        <li><a href="http://www.secfs.net/winfsp">WinFsp</a> - Windows File System Proxy</li>
        <li>virtiofs PCI device driver</li>
        <li>virtiofs service</li>
    </ul>

    <h2>Installing WinFsp</h2>
    <p>
        Download and run the latest stable version of the WinFsp installer:
        <p>
            <a href="https://github.com/billziss-gh/winfsp/releases/latest">
                <img src="https://camo.githubusercontent.com/a53ec1e332d589de5af87290e7d801dd4eaefc7c/68747470733a2f2f696d672e736869656c64732e696f2f6769746875622f72656c656173652f62696c6c7a6973732d67682f77696e6673702e7376673f6c6162656c3d737461626c65267374796c653d666f722d7468652d6261646765" data-canonical-src="https://img.shields.io/github/release/billziss-gh/winfsp.svg?label=stable&amp;style=for-the-badge" style="max-width:100%;">
            </a>
        </p>
    </p>

    <p>
        In the installer the default selected options are sufficient unless
        you plan to develop your own user-mode file system (or contibute to
        virtiofs for Windows).

        <p><img src="winfsp-installer.png"></p>
    </p>

    <p>
        You should not need to reboot unless WinFsp was already running on
        your system.
    </p>

    <h2>Installing the virtiofs PCI device driver</h2>
    <p>
        Start Computer Managenment and locate the virtiofs PCI device in the
        "Device Manager" tool. It should appear as a "Mass Storage Controller"
        under "Other devices".

        <p><img src="comp-mgr.png"></p>

        Right-click on the device and select "Update driver" from the pop-up
        menu. From the "Update Drivers" dialog choose "Browse my computer for
        drivers" and fill in the appropriate directory where the drivers files
        are located.

        If your operating system does not include a virtio-win driver ISO you
        can download it <a
        href="https://docs.fedoraproject.org/en-US/quick-docs/creating-windows-virtual-machines-using-virtio-drivers/#virtio-win-direct-downloads">here</a>.
    </p>

    <h2>Installing the virtiofs service</h2>
    <p>
        Run as administrator the Command Prompt and execute the following
        command in order to register virtiofs as a service which starts
        automatically when Windows loads.

        <pre>C:\> sc create VirtioFsSvc binpath="(your binary location)\virtiofs.exe" start=auto depend="WinFsp.Launcher/VirtioFsDrv" DisplayName="Virtio FS Service"</pre>

        A manual service start is done with the following command:

        <pre>C:\> sc start VirtioFsSvc</pre>
    </p>

    <p>
        virtiofs will use the first available drive letter starting with
        Z: and downward. Use the "-m" command line parameter to explicitly
        select a drive letter.
    </p>

    <div class="footer">
        <p>This website is published under the <a href="https://creativecommons.org/licenses/by-sa/4.0/">Creative Commons Attribution-ShareAlike 4.0 International</a> license. The source code is available <a href="https://gitlab.com/virtio-fs/virtio-fs.gitlab.io/">here</a>.</p>
    </div>
  </body>
</html>
